package com.company.vault.test;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Configuration;
import org.springframework.lang.NonNull;
import org.springframework.vault.authentication.ClientAuthentication;
import org.springframework.vault.authentication.TokenAuthentication;
import org.springframework.vault.client.VaultEndpoint;
import org.springframework.vault.config.AbstractVaultConfiguration;

import javax.inject.Inject;

@Configuration
public class VaultConfiguration extends AbstractVaultConfiguration {

    @Inject
    private VaultSettings vaultSettings;

    @Override
    @NonNull
    public VaultEndpoint vaultEndpoint() {
        final VaultEndpoint vaultEndpoint = new VaultEndpoint();
        vaultEndpoint.setScheme("http");
        return vaultEndpoint;
    }

    @Override
    @NonNull
    public ClientAuthentication clientAuthentication() {
        return new TokenAuthentication(vaultSettings.getVaultToken());
    }

}