package com.company.vault.test;

import com.haulmont.cuba.core.sys.DataSourceProvider;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.vault.core.VaultTemplate;
import org.springframework.vault.support.VaultResponseSupport;

import java.util.Map;

public class VaultDataSourceProvider extends DataSourceProvider {

    private static final Logger log = LoggerFactory.getLogger(VaultDataSourceProvider.class);

    @Autowired
    VaultTemplate vaultTemplate;

    @Override
    protected Map<String, String> getDataSourceParameters(String storeName) {
        log.info("Getting datasource parameters from vault");
        final VaultResponseSupport<DbConfig> response = vaultTemplate.read(
                "dbconfig/config", DbConfig.class);
        final DbConfig data = response.getData();

        final Map<String, String> dataSourceParameters = super.getDataSourceParameters(storeName);
        dataSourceParameters.put(USER_NAME, data.getUsername());
        dataSourceParameters.put(PASSWORD, data.getPassword());
        return dataSourceParameters;
    }
}